
CREATE OR REPLACE FUNCTION tcg.public.FN_before_insert_Error_Type()
RETURNS TRIGGER AS $$
DECLARE
    r_change_set RECORD;
BEGIN
    NEW.created_on = COALESCE(NEW.created_on, CURRENT_TIMESTAMP);
    NEW.updated_last_on = COALESCE(NEW.updated_last_on, CURRENT_TIMESTAMP);

    IF NEW.change_set_id IS NULL THEN
		RAISE EXCEPTION 'Change Set ID must be provided.';
    END IF;

    SELECT *
    INTO r_change_set
    FROM tcg.public.TCG_Change_Set CHANGE_SET
    WHERE NEW.change_set_id = CHANGE_SET.change_set_id
    ;

    IF FOUND THEN
        NEW.created_by_user_id := COALESCE(NEW.created_by_user_id, r_change_set.updated_last_by_user_id);
        NEW.updated_last_by_user_id := COALESCE(NEW.updated_last_by_user_id, r_change_set.updated_last_by_user_id);
        NEW.created_on := COALESCE(NEW.created_on, r_change_set.updated_last_on);
    ELSE
        RAISE EXCEPTION 'Change Set % not found.', NEW.change_set_id;
    END IF;

    RETURN NEW;
END;
$$ LANGUAGE plpgsql
;

CREATE OR REPLACE FUNCTION tcg.public.FN_before_update_Error_Type()
RETURNS TRIGGER AS $$
BEGIN
    NEW.updated_last_on = CURRENT_TIMESTAMP;

    IF OLD.change_set_id IS NOT DISTINCT FROM NEW.change_set_id THEN
		RAISE EXCEPTION 'New Change Set ID must be provided.';
    END IF;

    INSERT INTO tcg.public.Error_Type_Audit (
		  error_type_id
        , name_field
        , value_prev
        , value_new
        , change_set_id
    )
	-- Changed code
	SELECT NEW.error_type_id, 'code', OLD.code, NEW.code, NEW.change_set_id
		WHERE OLD.code IS DISTINCT FROM NEW.code
	UNION
	-- Changed name
	SELECT NEW.error_type_id, 'name', OLD.name, NEW.name, NEW.change_set_id
		WHERE OLD.name IS DISTINCT FROM NEW.name
	UNION
	-- Changed active
	SELECT NEW.error_type_id, 'active', OLD.active::TEXT, NEW.active::TEXT, NEW.change_set_id
		WHERE OLD.active IS DISTINCT FROM NEW.active
    ;
    
    RETURN NEW;
END;
$$ LANGUAGE plpgsql
;

CREATE TRIGGER TRI_before_insert_Error_Type
    BEFORE INSERT ON tcg.public.Error_Type
    FOR EACH ROW
    EXECUTE FUNCTION tcg.public.FN_before_insert_Error_Type()
;
CREATE TRIGGER TRI_before_update_Error_Type
    BEFORE UPDATE ON tcg.public.Error_Type
    FOR EACH ROW
    EXECUTE FUNCTION tcg.public.FN_before_update_Error_Type()
;